#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#ifdef SPUST_LINUX
#include <sys/time.h>
#include <sys/times.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <unistd.h>
#elif defined SPUST_WINDOWS
#include <windows.h>
#endif

#define MAX_N    1005
#define MAX_S 1000007

FILE *f;
int N,S=0;
int vahy[MAX_N];
short a[MAX_S], p[MAX_S];

void nacti() {
  int i;
  
  if (!(f=fopen("lup.in", "rt"))) puts("SPATNE: Nelze otevrit soubor lup.in!"), exit(1);
  fscanf(f,"%d",&N);
  for (i=0;i<N;i++) {
    fscanf(f,"%d",vahy+i);
    S+=vahy[i];
  }
  fclose(f);
}

void otestuj() {
  int i,M=-1,S2=0;

  if (!(f=fopen("lup.out", "rt"))) puts("SPATNE: Nelze otevrit soubor lup.out!"), exit(1);

  if (!fscanf(f,"%d",&M)) puts("SPATNE: Nelze nacist pocet predmetu!"), exit(1);
  if (M<0 || M>N) puts("SPATNE: Pocet predmetu je mimo rozsah!"), exit(1);
  if (M==0 && (N&1)) puts("SPATNE: Soutezici chybne rekl, ze reseni neexistuje!"), exit(1);
  if (M==0 && !(N&1)) puts("DOBRE: Soutezici spravne rekl, ze reseni neexistuje."), exit(0);
  if (M>0 && !(N&1)) puts("SPATNE: Soutezici chybne rekl, ze reseni existuje!"), exit(1);

  for (i=0;i<M;i++) {
    int j=-1;
    if (!fscanf(f,"%d",&j)) printf("SPATNE: Nelze nacist index %d-teho predmetu!", i+1), exit(1);
    if (j<1 || j>N) printf("SPATNE: Index %d-teho predmetu je mimo rozsah!", i+1), exit(1);
    S2+=vahy[j-1];
  }
  if (2*S2 != S) puts("SPATNE: Soutezici navrhl reseni, ale je chybne!"), exit(1);
  puts("DOBRE: Soutezici navrhl spravne reseni.");
  fclose(f);
}

int main(int argc, char *argv[]) {

#ifdef SPUST
  char *in, fname[10];

  if (argc!=3) printf("Pouziti: otestuj_a_spust vstup spustitelne_reseni\n"
		      " kde -vstup je m1a, m1b, m2a, ..., m6b, z1a, ... z6b\n"
		      "     -spustitelne reseni je prikaz, ktery spousti reseni souteziciho.\n"
		      "        Pokud obsahuje mezeru, napiste cely prikaz v uvozovkach.\n"), exit(1);

  in=argv[1];
  if (strlen(in)!=3 || 
      !(in[0]=='z' || in[0]=='m') ||
      !(in[1]>='1' && in[1]<='6') ||
      !(in[2]=='a' || in[2]=='b'))
    printf("Spatny nazev vstupu: musi byt jedna z hodnot m1a, m1b, m2a, ..., m6b, z1a, ..., z6b\n"), exit(1);
  strcpy(fname, in);
  strcat(fname, ".txt");

  { FILE *fr, *fw; int c;
    if (!(fr=fopen(fname, "rt"))) printf("Chybi soubor %s se vstupnimi daty!\n", fname), exit(1);
    if (!(fw=fopen("lup.in", "wt"))) printf("Nelze zkopirovat vstup do souboru lup.in!\n"), exit(1);
    while (c=fgetc(fr), c!=EOF) fputc(c, fw);
    fclose(fr);
    fclose(fw);
  }
  remove("lup.out");  
  
  printf("Spoustim reseni od souteziciho... ");
  fflush(stdout);
#endif
#ifdef SPUST_LINUX  
  struct tms start; times(&start);
  { struct rlimit l={5, 5}; setrlimit(RLIMIT_CPU, &l); }
  if (WIFSIGNALED(system(argv[2]))) printf("reseni spadlo nebo bylo zabito po 5 sekundach.\nSPATNE\n"), exit(1);
  else {
    struct tms now; times(&now); int ms=(now.tms_cutime-start.tms_cutime) * 1000 / sysconf(_SC_CLK_TCK);
    if (ms>5000) printf("prekrocilo limit 5s!\nSPATNE\n"), exit(1); //this line should never execute, but :)
    printf ("skoncilo za %dms.\n", ms);
  }
#elif defined SPUST_WINDOWS
  STARTUPINFO si; ZeroMemory(&si, sizeof(si)); si.cb=sizeof(si); PROCESS_INFORMATION pi;
  if (!CreateProcess(NULL,argv[2],NULL,NULL,FALSE,0,NULL,NULL,&si,&pi)) printf("Nelze spustit zadane reseni!\n"),exit(1);
  DWORD ms, running=0;
  do {
    running=WaitForSingleObject(pi.hProcess,1000)==WAIT_TIMEOUT;
    FILETIME tmp[4];
    if (!GetProcessTimes(pi.hProcess,tmp+0,tmp+1,tmp+2,tmp+3)) printf("Nelze merit cas zadaneho reseni!\n"),exit(1);
    ms=(tmp[3].dwLowDateTime/10000)+tmp[3].dwHighDateTime*429497;
  } while (running && ms<5000);
  if (running) TerminateProcess(pi.hProcess, 1); CloseHandle(pi.hProcess); CloseHandle(pi.hThread);
  if (ms>5000) printf("prekrocilo limit 5s!\nSPATNE\n"), exit(1); //unlike the Linux test this will happen :)
  printf("skoncilo za %ldms.\n", ms);
#endif  

  nacti();
  otestuj();

  return 0;
}
